EVstrong2=function(m,m1,si,pi,IFP,ITP){
m0=m-m1
return(m0*si*IFP+m1*(1-pi)*si*ITP)
}

EVstrong1=function(alpha,m,m1,si,pi,ITN,IFN,delta){
m0=m-m1
#return(m0*si*ITN+m1*(1-pi)*si*IFN)
return(si*(m0+m1*(1-pi))*(m0*ITN+m1*(1-pi)*IFN)/(m0*(1-alpha/m)+m1*pnorm(qnorm(1-alpha/m)-pi*delta)))
}

################################################################################
ComputeIFP=function(alpha,k,m,si,ui){
uj=qnorm(1-k*alpha/(m*si))
(rho=1/sqrt(si))
integrand <- function(x) {(1-pnorm((ui-rho*x)/(sqrt(1-rho^2))))*dnorm(x)}
(IFP = integrate(integrand, lower = uj, upper = Inf)$value)
return(IFP)
}

ComputeITP=function(alpha,k,m,si,pi,delta,m1,ui){
uj=qnorm(1-k*alpha/(m*si))
(rho=1/sqrt(si))
integrand2 <- function(x) {(1-pnorm((ui-delta*pi*sqrt(si)-rho*x)/(sqrt(1-rho^2))))*dnorm(x)}
(ITP = integrate(integrand2, lower = uj, upper = Inf)$value)
return(ITP)
}

ComputeITN=function(alpha,strong,m,si,ui){
uj=qnorm(1-1/strong*alpha/(m*si))
(rho=1/sqrt(si))
integrand <- function(x) {(pnorm((ui-rho*x)/(sqrt(1-rho^2))))*dnorm(x)}
(ITN = integrate(integrand, lower = uj, upper = Inf)$value)
return(ITN)
}

ComputeIFN=function(alpha,strong,m,si,pi,delta,m1,ui){
uj=qnorm(1-1/strong*alpha/(m*si))
(rho=1/sqrt(si))
integrand2 <- function(x) {(pnorm((ui-delta*pi*sqrt(si)-rho*x)/(sqrt(1-rho^2))))*dnorm(x)}
(IFN = integrate(integrand2, lower = uj, upper = Inf)$value)
return(IFN)
}




computeK2=function(alpha,m,si,scoresMatrix,step,initK,ui){
k=initK
temp=0

while (temp<=alpha){
k=k+step
EV=NULL
IFP=ComputeIFP(alpha,k,m,si,ui)
for(m1 in seq(m/20,m/5, m/10)){
for(pi in seq(0.1,0.5,0.1)){
maxd=mean(sort(as.vector(scoresMatrix),decreasing = TRUE)[1:(m1*pi*si)])# max(2*sqrt(log(max(1,(s0+s1*(1-pi))*mi))),d-sqrt(log(2*max(1,s1*pi*mi))))
for(delta in (c(maxd))){
ITP=ComputeITP(alpha,k,m,si,pi,delta,m1,ui)
EV=c(EV, EVstrong2(m,m1,si,pi,IFP,ITP))
}
}
}
temp=max(EV)
}
return(k-step)
}


computeK3=function(alpha,strong=2,m,si,scoresMatrix,step=0.2,initK=1,ui){
k=initK
temp=0
while (temp<=alpha){
k=k+step
EV=NULL
IFP=ComputeIFP(alpha,k,m,si,ui)
ITN=ComputeITN(alpha,strong,m,si,ui)
for(m1 in seq(m/20,m/5, m/20)){
for(pi in seq(0.05,0.5,0.05)){
maxd=mean(sort(as.vector(scoresMatrix),decreasing = TRUE)[1:(m1*pi*si)])
for(delta in (c(1:4*maxd)/4)){
ITP=ComputeITP(alpha,k,m,si,pi,delta,m1,ui)
IFN=ComputeIFN(alpha,strong,m,si,pi,delta,m1,ui)
EV=c(EV, EVstrong2(m,m1,si,pi,IFP,ITP)+EVstrong1(alpha,m,m1,si,pi,ITN,IFN,delta))#   
}
}
}
temp=max(EV)
}
return(k-step)
}
