GlobalVectorAnalysis=function(path,data_separ,masking,mask_path,mask_separ,regress_separ,summaryFunctionName, binarize, weighted, testType="parametric",alternative, regressors_file=NULL,regress = FALSE,paired=FALSE){
source(paste(connectomeAnalyzerPath,'loadData.r',sep=""))

if(weighted == FALSE){
weighted = NULL}

data = loadData(path,separ=data_separ,masking,mask_path,mask_separ)
library(igraph)
source(paste(connectomeAnalyzerPath,"SummaryFunctions.r", sep=""))
summaryFunction=get(summaryFunctionName)
dataGroup1=data$dataGroup1
n1=dim(dataGroup1)[3]
dataGroup2=data$dataGroup2
n2=dim(dataGroup2)[3]
M= dim(dataGroup2)[1]

if(binarize){
	dataGroup1[dataGroup1 > 0 | dataGroup1 < 0] = 1
	dataGroup2[dataGroup2 > 0 | dataGroup2 < 0] = 1
}

group1=NULL
for(k in 1:n1){
group1=c(group1, summaryFunction((dataGroup1[,,k,]),weighted = weighted))
}

group2=NULL
for(k in 1:n2){
group2=c(group2, summaryFunction((dataGroup2[,,k,]),weighted = weighted))
}

regressors = NULL
if(regress){
	source(paste(connectomeAnalyzerPath,"load_regressors.r",sep=""))
	regressors = loadRegressors(regressors_file,regress_separ,data$names)	
	vect = c(group1,group2)
	dat=data.frame(vect, regressors)
	vect_fit=lm(vect~., dat=dat)
	obj = summary(step(vect_fit, trace=0))
	temp=obj$coefficients[1]+ obj$residuals
	group1 = temp[1:length(group1)]
	group2 = temp[(length(group1)+1):length(temp)]
	regressors = NULL
}

#print("The p.value obtained with the t.test (no regressors) is")
print(paste("The p.value for ",summaryFunctionName," is",sep=""))
if(testType=='parametric')
{
print(t.test(group1, group2, alternative,paired=paired)$p.value)
}
else
{
print(as.numeric((wilcox.test(group1,group2, paired=paired, alternative=alternative)$p.value)[1]))
}
}
