library(igraph)

Labels83=read.table(paste(connectomeAnalyzerPath,"Label33.r",sep=""), header=FALSE)
xyz=t(read.table(paste(connectomeAnalyzerPath,"Cordinates xyz brain 33ROI.txt",sep="")))

x=xyz[,1]
y=xyz[,2]
z=xyz[,3]
###############################################################################
#label2=c("LOF", "PORB", "FP", "MOF", "PTRI", "POPE", "RMF", "SF", "CMF", "PREC", "PARC", "RAC", "CAC", "PC", "ISTC", "PSTS", "SMAR", "SP", "IP", "PCUN", "CUN", "PCAL", "LOCC", "LING", "FUS", "PARH", "ENT", "TP", "IT", "MT",  "BSTS", "ST", "TT","TAH","CAU","PUT","PLD","ACC","STH","HYPO","AMYG")

#leftLabel=c(rep(NULL, 41))
#rightLabel=c(rep(NULL, 41))

#for(j in 1:41) leftLabel[j]=paste("l", label2[j], sep="")
#for(j in 1:41) rightLabel[j]=paste("r", label2[j], sep="")

#labels=c(rightLabel,leftLabel,"STEM")


################################################################################
plot.Graph2=function(data, matrixOfSignificance, labels=FALSE, nodesColor="greenyellow", edgesColor="yellow2", section="Dorsal"){
library(igraph)

adjm=apply(data$dataGroup1,c(1,2),mean)
diag(adjm)=0

maxValue=max(adjm)
adjm[matrixOfSignificance==1]=2*maxValue
G <- graph.adjacency((adjm), mode="undirected", weighted=TRUE)


V(G)$size=4
sigVect=as.numeric(apply(matrixOfSignificance,1,sum)>0)

V(G)$color="grey95"
V(G)$frame.color="grey95"
V(G)$frame.width=0.2

V(G)$color[sigVect==1]=nodesColor
V(G)$frame.color[sigVect==1]=nodesColor
V(G)$size[sigVect==1]=6

E(G)$width=0.5
E(G)$color="grey95"
E(G)[E(G)$weight==2*maxValue]$width=5
E(G)[E(G)$weight==2*maxValue]$color=edgesColor
V(G)$label=""

if (length(labels)>1){
V(G)$label=labels
V(G)$label.dist=0.3
V(G)$label.cex=0.6

V(G)[sigVect==0]$label.color="grey"
V(G)[sigVect==0]$label.cex=0.6
V(G)$label.cex[sigVect==1]=1.2
}

E(G)[E(G)$weight==3*maxValue]$color="orange"
E(G)[E(G)$weight==3*maxValue]$width=5

if(section=="Dorsal"){
plot(G, layout=cbind(x,y))
}

if(section=="Lateral"){
plot(G, layout=cbind(-1.5*y,z))
}

return(G)
}


##################################################################################
################################################################################
plot.Graph=function(data, matrixOfSignificance, labels=FALSE, nodesColor="greenyellow", edgesColor="yellow2", section="Dorsal", nonSignificantColor="grey92", edgesWidthCoef=1, secondColor="red", secondMatrix=NULL,thirdColor="orange", thirdMatrix=NULL){
library(igraph)

adjm=apply(data$dataGroup1,c(1,2),mean)
diag(adjm)=0


G <- graph.adjacency((adjm), mode="undirected", weighted=TRUE)

V(G)$size=4

V(G)$color=nonSignificantColor
V(G)$frame.color=nonSignificantColor
V(G)$frame.width=0.2

E(G)$width=0.1
E(G)$color=nonSignificantColor

V(G)$label=""

if(section=="Dorsal"){
plot(G, layout=cbind(x,y))
}

if(section=="Lateral"){
plot(G, layout=cbind(y,z))
}


sigVect=as.numeric(apply(matrixOfSignificance,1,sum)>0)

G <- graph.adjacency((matrixOfSignificance), mode="undirected", weighted=TRUE)
V(G)[sigVect==1]$color=nodesColor
V(G)[sigVect==1]$frame.color=nodesColor
V(G)$size=6
V(G)$label=""
E(G)$width=edgesWidthCoef*(1-qnorm(E(G)$weight))
E(G)$color=edgesColor
if (length(labels)>1){
V(G)$label=labels
V(G)$label.dist=0.3
V(G)$label.cex=0.6


V(G)[sigVect==0]$label.color=nonSignificantColor
V(G)[sigVect==0]$label.cex=0.5
V(G)[sigVect==1]$label.cex=1
}

op <- par(new=T)

if(section=="Dorsal"){
plot(G, layout=cbind(x,y))
}

if(section=="Lateral"){
plot(G, layout=cbind(y,z))
}
par(op)


if (length(as.vector(secondMatrix))>1){
G <- graph.adjacency((secondMatrix), mode="undirected", weighted=TRUE)
V(G)[sigVect==1]$color=nodesColor
V(G)[sigVect==1]$frame.color=nodesColor
V(G)$size=6
V(G)$label=""
E(G)$width=edgesWidthCoef*(1-qnorm(E(G)$weight))
E(G)$color=secondColor


if (length(labels)>1){
V(G)$label=labels
V(G)$label.dist=0.3
V(G)$label.cex=0.6


V(G)[sigVect==0]$label.color=nonSignificantColor
V(G)[sigVect==0]$label.cex=0.5
V(G)[sigVect==1]$label.cex=1
}

op <- par(new=T)
if(section=="Dorsal"){
plot(G, layout=cbind(x,y))
}

if(section=="Lateral"){
plot(G, layout=cbind(y,z))
}
par(op)
}

if (length(as.vector(thirdMatrix))>1){
G <- graph.adjacency((thirdMatrix), mode="undirected", weighted=TRUE)
V(G)[sigVect==1]$color=nodesColor
V(G)[sigVect==1]$frame.color=nodesColor
V(G)$size=6
V(G)$label=""
E(G)$width=edgesWidthCoef*(1-qnorm(E(G)$weight))
E(G)$color=thirdColor


if (length(labels)>1){
V(G)$label=labels
V(G)$label.dist=0.3
V(G)$label.cex=0.6


V(G)[sigVect==0]$label.color=nonSignificantColor
V(G)[sigVect==0]$label.cex=0.5
V(G)[sigVect==1]$label.cex=1
}

op <- par(new=T)
if(section=="Dorsal"){
plot(G, layout=cbind(x,y))
}

if(section=="Lateral"){
plot(G, layout=cbind(y,z))
}
par(op)
}
}