SWA=function(path,data, SubregionsIndices, sum_func_name = "mean",summaryFunction=mean, WieghtsMatrix=1, option="one region to one region", alpha=0.05, MCPprocedure="bonferroni",testType = "parametric", paired=FALSE, alternative="two.sided",regressors=NULL, plotResults=FALSE){

s=length(unique(SubregionsIndices[,1]))     
library(igraph)
reducedGroup1=reduceData(data$dataGroup1, summaryFunction=summaryFunction, SubregionsIndices,option=option)$reducedData    
reducedGroup2=reduceData(data$dataGroup2, summaryFunction=summaryFunction, SubregionsIndices,option=option)$reducedData

source(paste(connectomeAnalyzerPath,"computeMatrixPvalues.r", sep=""))
matrixOfPval=computeMatrixPvalues(reducedGroup1,reducedGroup2,option=option,connectomeAnalyzerPath=connectomeAnalyzerPath,testType = testType, paired=paired, alternative=alternative,regressors=regressors)
#print(min(matrixOfPval$MatrixOfPvalues))

source(paste(connectomeAnalyzerPath,"getThreshold.r", sep=""))

out=getThreshold(MatrixOfPvalues=matrixOfPval, alpha=alpha,WieghtsMatrix=WieghtsMatrix, MCPprocedure=MCPprocedure,option=option)
BlockPvalues=matrixOfPval$MatrixOfPvalues
ResultsMatrix=matrixOfPval$MatrixOfPvalues<=out$threshold
print ("The number of rejections is")
R=(sum(ResultsMatrix)/2+sum(diag(ResultsMatrix))/2)
print(R)
if (R>0){
#print(ResultsMatrix) 
is(sum_func_name)
write.table(ResultsMatrix, paste(path, "/Results/", sum_func_name,"_", MCPprocedure,"_",alternative,"_","SWA.csv", sep=""))    
if (plotResults==TRUE){ 
g=graph.adjacency(matrix(as.numeric(ResultsMatrix), ncol=dim(ResultsMatrix)[1]))        
g=graph.adjacency(matrix(as.numeric(ResultsMatrix), ncol=dim(ResultsMatrix)[1]))
V(g)$label=as.character(1:s)
png(paste(path, "/Results/",MCPprocedure,"_",alternative,"_","SWA.png", sep=""),width = 960, height = 960,
    units = "px", pointsize = 12, bg = "white", res = NA,
    restoreConsole = TRUE)
plot(g,layout=layout.circle)
dev.off()
}
}
SWAresults=NULL
SWAresults$BlockPvalues=BlockPvalues
SWAresults$BlocResultsMatrix=ResultsMatrix
SWAresults$R=R
return(SWAresults)
}


