localAnalysis=function(connectomeAnalyzerPath,dataGroup1, dataGroup2, alpha=0.05, testType="parametric", permutations = 10000, MCPprocedure="bonferroni", alternative="two.sided", paired=FALSE, regressors=NULL){
source(paste(connectomeAnalyzerPath,"computePvalue.r", sep=""))
source(paste(connectomeAnalyzerPath,"P.adjust.r", sep=""))
#library(fields)
N=dim(dataGroup1)[2]
n_variates = dim(dataGroup1)[4]
p_values=NULL
pValuesMatrix=matrix(NA, N,N)
scoresMatrix=matrix(NA, N,N)
MatrixOfOmmission=matrix(FALSE, N,N)
numberOfTests=0

for(i in 1:N){
	for(j in 1:i ){
		if(sum(var(dataGroup1[i,j,,]))!=0 && sum(var(dataGroup2[i,j,,]))!=0){
  			p_values=c(p_values,computePvalue(dataGroup1[i,j,,],dataGroup2[i,j,,], testType = testType, permutations = permutations, alternative=alternative,paired=paired, regressors=regressors)$p.value)
  			numberOfTests=numberOfTests+1
  		}
  	}
  	for(j in 1:N){
 		if(var(dataGroup1[i,j,,])!=0 && var(dataGroup2[i,j,,])!=0){
			#  if((sum(dataGroup1[i,j,,]!=0)>0.75*length(dataGroup1[i,j,,])) && (sum(dataGroup2[i,j,,]!=0)>0.75*length(dataGroup2[i,j,,]))){
  			pValuesMatrix[i,j]=computePvalue(dataGroup1[i,j,,],dataGroup2[i,j,,], testType = testType, permutations = permutations, alternative=alternative,paired=paired, regressors=regressors)$p.value
  			scoresMatrix[i,j]=qnorm(1-pValuesMatrix[i,j])
  		}
  		else{
  			pValuesMatrix[i,j]=0.5
  			scoresMatrix[i,j]=0
  			MatrixOfOmmission[i,j]=TRUE
  		}
 	}
} 
         
if (MCPprocedure!="pfdr"){
	adjusted.p_values=p.adjust2(p_values, MCPprocedure)
}
else{
	adjusted.p_values=qvalue(p_values,pi0.method="bootstrap")$qvalues
}

options(show.error.messages = FALSE)
(threshold=max(c(p_values[adjusted.p_values<=alpha]),-1))

options(show.error.messages = TRUE)
if(threshold>0) {

}
if(threshold<=0){ 
print("No significant results")
print("The minimum adjusted p.value is")
print(min(adjusted.p_values))
} 
localAnalysis=NULL
localAnalysis$pValuesMatrix=pValuesMatrix
localAnalysis$numberOfTests=numberOfTests
localAnalysis$threshold=threshold
localAnalysis$minimum.adjusted.pvalue=min(adjusted.p_values)
localAnalysis$adjusted.p_values=adjusted.p_values 
localAnalysis$p_values=p_values
localAnalysis$scoresMatrix=scoresMatrix 
localAnalysis$MatrixOfOmmission=MatrixOfOmmission 
return(localAnalysis)
}
