relaxPvalues=function(matrix_to_relax, data_separ = ',', decomposition_file, decomposition_separ=',',alpha=0.05, alpha2=0.05, strong=1, procedure="bonferroni"){
path_parts = strsplit(matrix_to_relax, "\\.")[[1]]
file_basename = path_parts[1]
file_extension = path_parts[2]
temp = read.table(matrix_to_relax,header=FALSE,sep=data_separ)
p_values = as.vector(temp[,1])
SubregionsIndices = read.table(decomposition_file,sep=decomposition_separ)
source(paste(connectomeAnalyzerPath,"ConstructVectorFilter.r", sep=""))
p.values = p_values
M=length(p.values)
sm=length(unique(SubregionsIndices[,1]))
scores=qnorm(1-p.values)
#scores[scores==-Inf]=0
si=M/sm

reducedData=NULL
for (ir in 1:sm){    # ir is the row index of the brain subregion i,
rowIndex=as.vector(SubregionsIndices[,2][SubregionsIndices[,1]==ir])
reducedData=c(reducedData, mean(scores[rowIndex]))
}

print("The number of significant results with the AWA")
print(sum(p.adjust(p.values, procedure)<=alpha))
AWA=as.numeric(p.adjust(p.values, procedure)<=alpha)
pAWA=p.adjust(p.values, procedure)
write.table(pAWA, paste(file_basename,'_',procedure,'_alpha-',alpha,'_AWA.csv', sep=""))
if (sum(p.adjust(p.values,procedure)<=alpha)>0){
print("The significant locations are")
print(c(1:M)[p.adjust(p.values,procedure)<=alpha])
}

P.values=1-pnorm(reducedData)

R=sum(p.adjust(P.values, procedure)<=alpha)
ui1= qnorm(1-alpha/(sm))
if (procedure=="BH"){
ui1= qnorm(1-max(1,R)*alpha/(sm))
}
if (procedure=="fdr"){
ui1= qnorm(1-max(1,R)*alpha/(sm))
}
ui2= qnorm(1-alpha)

ui3=ui1

# compute relaxation coeficient
#Scores= qnorm(1-p.values)
source(paste(connectomeAnalyzerPath,"ComputeK.r", sep=""))
relaxation1=computeK2(alpha2, sm, si=si,scoresMatrix=scores,step=0.05,initK=1,ui1)

VectorOfSignificantSubsets=P.values<=1-pnorm(ui1)
Filter1=ConstructVectorFilter(VectorOfSignificantSubsets, SubregionsIndices)
print("The number of significant results with the RMWC")
relaxed.p.values=((p.values/relaxation1)*Filter1+(1-Filter1))
print(sum(p.adjust(relaxed.p.values,procedure)<=alpha2))
RMWC=as.numeric (p.adjust(relaxed.p.values,procedure)<=alpha2)
pRMWC=p.adjust(relaxed.p.values,procedure)
write.table(pRMWC, paste(file_basename,'_',procedure,'_alpha1-',alpha,'_alpha2-',alpha2,'_RMWC.csv', sep=""))
if (sum(p.adjust(relaxed.p.values,procedure)<=alpha2)>0){
print("The significant locations are")
print(c(1:M)[p.adjust(relaxed.p.values,procedure)<=alpha2])
}

relaxation2=computeK2(alpha2, sm, si=si,scoresMatrix=scores,step=0.05,initK=1,ui2)
VectorOfSignificantSubsets=P.values<=1-pnorm(ui2)
Filter2=ConstructVectorFilter(VectorOfSignificantSubsets, SubregionsIndices)
print("The number of significant results with the RMNC")
relaxed.p.values=((p.values/relaxation2)*Filter2+(1-Filter2))
print(sum(p.adjust(relaxed.p.values,procedure)<=alpha2))
RMNC=as.numeric (p.adjust(relaxed.p.values,procedure)<=alpha2)
pRMNC=p.adjust(relaxed.p.values,procedure)
write.table(pRMNC, paste(file_basename,'_',procedure,'_alpha1-',alpha,'_alpha2-',alpha2,'_RMNC.csv', sep=""))
if (sum(p.adjust(relaxed.p.values,procedure)<=alpha2)>0){
print("The significant locations are")
print(c(1:M)[p.adjust(relaxed.p.values,procedure)<=alpha2])
}
relaxation3=computeK3(alpha2, sm, si=si,strong=strong, scoresMatrix=scores,step=0.05,initK=1,ui3)
VectorOfSignificantSubsets=P.values<=1-pnorm(ui3)
Filter3=ConstructVectorFilter(VectorOfSignificantSubsets, SubregionsIndices)
print("The number of significant results with the RMIO")
relaxed.p.values=(p.values/relaxation3)*Filter3+(p.values*strong)*(1-Filter3)
print(sum(p.adjust(relaxed.p.values,procedure)<=alpha2))
RMIO=as.numeric (p.adjust(relaxed.p.values,procedure)<=alpha2)
pRMIO=p.adjust(relaxed.p.values)
write.table(pRMIO, paste(file_basename,'_',procedure,'_alpha1-',alpha,'_alpha2-',alpha2,'_strong-',strong,'_RMIO.csv', sep=""))
if (sum(p.adjust(relaxed.p.values,procedure)<=alpha2)>0){
print("The significant locations are")
print(c(1:M)[p.adjust(relaxed.p.values,procedure)<=alpha2])
}
}
