source(paste(connectomeAnalyzerPath,"localAnalysis.r", sep=""))
relaxed2step=function(localResults,alpha=0.05,relaxation1,relaxation2,relaxation3,strong=1,SubregionsIndices,MCPprocedure="bonferroni",alternative="two.sided",connectomeAnalyzerPath,option,ui,Filter="none"){

localScoresMatrix=localResults$scoresMatrix
localMatrixOfOmmission=localResults$MatrixOfOmmission

source(paste(connectomeAnalyzerPath,"reduceData2.r", sep=""))
BlockScoreMatrix=reduceData2(matrix=localScoresMatrix, localMatrixOfOmmission=localMatrixOfOmmission, summaryFunction=summaryFunction, SubregionsIndices=SubregionsIndices,option=option)

WieghtsMatrix=BlockScoreMatrix$WieghtsMatrix
temp=c(as.vector(WieghtsMatrix),diag(WieghtsMatrix))
meanWeights=mean(temp[temp!=0])

WieghtsMatrix=WieghtsMatrix/meanWeights

sm=dim(WieghtsMatrix)[1]
MatrixOfPvalues=matrix(NA,sm,sm)
for(ir in 1:sm){
for(ic in 1:sm){
if(WieghtsMatrix[ir,ic]!=0){

if (alternative=="two.sided"){
MatrixOfPvalues[ir,ic]=2*(1-pnorm(abs(BlockScoreMatrix$BlockScoresMatrix[ir,ic])))/WieghtsMatrix[ir,ic]
}
if (alternative=="greater"){
MatrixOfPvalues[ir,ic]=(1-pnorm(BlockScoreMatrix$BlockScoresMatrix[ir,ic]))/WieghtsMatrix[ir,ic]
}
if (alternative=="less"){
MatrixOfPvalues[ir,ic]=(pnorm(BlockScoreMatrix$BlockScoresMatrix[ir,ic]))/WieghtsMatrix[ir,ic]
}

}

if(WieghtsMatrix[ir,ic]==0){
if (alternative=="two.sided"){
MatrixOfPvalues[ir,ic]=2*(1-pnorm(abs(BlockScoreMatrix$BlockScoresMatrix[ir,ic])))
}
if (alternative=="greater"){
MatrixOfPvalues[ir,ic]=(1-pnorm(BlockScoreMatrix$BlockScoresMatrix[ir,ic]))
}
if (alternative=="less"){
MatrixOfPvalues[ir,ic]=(pnorm(BlockScoreMatrix$BlockScoresMatrix[ir,ic]))
}
}
}
}

WieghtsMatrix=BlockScoreMatrix$WieghtsMatrix
temp=c(as.vector(WieghtsMatrix),diag(WieghtsMatrix))
meanWeights=mean(temp[temp!=0])

WieghtsMatrix=WieghtsMatrix/meanWeights

MatrixOfOmmission=BlockScoreMatrix$WieghtsMatrix==0


MatrixPvalues=NULL
MatrixPvalues$MatrixOfPvalues=MatrixOfPvalues
MatrixPvalues$MatrixOfOmmission=MatrixOfOmmission
MatrixPvalues$scoresMatrix=BlockScoreMatrix$BlockScoresMatrix

matrixOfPval=MatrixPvalues

min(matrixOfPval$MatrixOfPvalues)
source(paste(connectomeAnalyzerPath,"getThreshold.r", sep=""))
out=getThreshold(matrixOfPval,WieghtsMatrix, alpha, MCPprocedure=MCPprocedure,option=option) #      

threshold=out$threshold

if(out$threshold==0){
threshold=-1
}
 
BlockResults=(matrixOfPval$MatrixOfPvalues<=threshold)
source(paste(connectomeAnalyzerPath,"ConstructFilter.r", sep=""))

matrix=matrixOfPval$MatrixOfPvalues<=1-pnorm(ui)#out$threshold
if ((is(Filter)=="character")[1]){
Filter=ConstructFilter(matrix=matrix, SubregionsIndices=SubregionsIndices, option=option)
}

newMatrixOfPvalues1=localResults$pValuesMatrix*(1-Filter)+1/relaxation1*Filter*localResults$pValuesMatrix
newMatrixOfPvalues2=(1-Filter)+1/relaxation2*Filter*localResults$pValuesMatrix
newMatrixOfPvalues3=strong*localResults$pValuesMatrix*(1-Filter)+1/relaxation3*Filter*localResults$pValuesMatrix

TwoStepLocalResults=NULL
TwoStepLocalResults$MatrixOfPvaluesMethod1=newMatrixOfPvalues1
TwoStepLocalResults$MatrixOfPvaluesMethod2=newMatrixOfPvalues2
TwoStepLocalResults$MatrixOfPvaluesMethod3=newMatrixOfPvalues3

SubsetWiseResults=NULL
SubsetWiseResults$ScoresMatrix=BlockScoreMatrix$BlockScoresMatrix
SubsetWiseResults$MatrixOfOmmission=MatrixOfOmmission
SubsetWiseResults$WeightsMatrix=WieghtsMatrix
SubsetWiseResults$BlockResults=BlockResults
sum(BlockResults )/2+sum(diag(BlockResults))/2
Results=NULL
Results$localResults=localResults
Results$SubsetWiseResults=SubsetWiseResults
Results$TwoStepLocalResults=TwoStepLocalResults

return(Results)
}